/*
This file is part of DeNa Drive.

DeNa Drive is free software: you can redistribute it and/or modify it under the terms of the
GNU General Public License as published by the Free Software Foundation,
either version 3 of the License, or (at your option) any later version.

DeNa Drive is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with DeNa Drive.
If not, see <https://www.gnu.org/licenses/>.
*/

package com.bbc.denadrive.apihandlers

import android.util.Log
import androidx.compose.runtime.MutableState
import androidx.compose.runtime.mutableStateOf
import androidx.lifecycle.ViewModel
import com.bbc.denadrive.FolderTree

class ResponsesViewer: ViewModel() {

    val rootFolder: MyFile = MyFile(
        kind = "drive#file",
        mimeType = "application/vnd.google-apps.folder",
        id = "root",
        name = "My Drive"
    )

    val lastResponseBody: MutableState<DriveResponseBody?> = mutableStateOf(null)
    val folderTree: FolderTree = FolderTree(rootFolder)
    val currentFolderTree: MutableState<FolderTree> = mutableStateOf(folderTree)
    val updater1: MutableState<Boolean> = mutableStateOf(false)
    val updater2: MutableState<Boolean> = mutableStateOf(true)

    fun toggleUpdaters() {
        Log.e("UPDATE", "toggleUpdaters: updating...", )
        updater1.value = !updater1.value
        updater2.value = !updater2.value
    }

//    private var lastResponse: String = ""
//    private var isComplete: Boolean = true
//    private lateinit var respBuilder: StringBuilder
    
    fun newResponseArrived(response: String?) {
        if (response == null) return
        lastResponseBody.value = ResponsesHandler.newResponseArrived<DriveResponseBody>(response)
    }


//    private fun checkForCompleteness(): Pair<Boolean, DriveResponseBody?> {
//        return try {
//            Pair(true, Json.decodeFromString<DriveResponseBody>(respBuilder.toString()))
//        } catch (e: SerializationException) {
//            Pair(false, null)
//        }
//    }

//    private fun updateCompleteness() {
//        val pair = checkForCompleteness()
//        isComplete = pair.first
//        if (isComplete) {
//            lastResponse = respBuilder.toString()
//            lastResponseBody.value = pair.second
//        }
//    }

}